#ifndef _TEST_TPCPAR_H_
#define _TEST_TPCPAR_H_
/*****************************************************************************/

/*****************************************************************************/
#include "tpcclibConfig.h"
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
/*****************************************************************************/
#include "tpcpar.h"
/*****************************************************************************/

/*****************************************************************************/
/* par */
extern int test_parInit(TPCSTATUS *status);
extern int test_parrInit(TPCSTATUS *status);
extern int test_parnInit(TPCSTATUS *status);
extern int test_parFree(TPCSTATUS *status);
extern int test_parrFree(TPCSTATUS *status);
extern int test_parAllocate(TPCSTATUS *status);
extern int test_parAllocateMore(TPCSTATUS *status);
extern int test_parrAllocate(TPCSTATUS *status);
extern int test_parEnsureNames(TPCSTATUS *status);
extern int test_parIsWSS(TPCSTATUS *status);
extern int test_parIsFitRange(TPCSTATUS *status);
extern int test_parIsModel(TPCSTATUS *status);
extern int test_parSDWithPar(TPCSTATUS *status);
extern int test_parCLWithPar(TPCSTATUS *status);
extern int test_parIsFitNr(TPCSTATUS *status);
extern int test_parIsDataNr(TPCSTATUS *status);
extern int test_parIsOptcrit(TPCSTATUS *status);
extern int test_parIsStudyNr(TPCSTATUS *status);
extern int test_parSetStudyNr(TPCSTATUS *status);
extern int test_parDeletePar(TPCSTATUS *status);
extern int test_parDeleteTAC(TPCSTATUS *status);
extern int create_par(PAR *par);
extern int create_par_ift(PAR *par);
/*****************************************************************************/

/*****************************************************************************/
/* parcsv */
extern int test_parWriteCSV(TPCSTATUS *status);
extern int test_parReadCSV(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* parift */
extern int test_parWriteIFT(TPCSTATUS *status);
extern int test_parToIFT(TPCSTATUS *status);
extern int test_parFromIFT(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* parxmlio */
extern int test_parWriteXML(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* pario */
extern int test_parFormattxt(TPCSTATUS *status);
extern int test_parFormatIdentify(TPCSTATUS *status);
extern int test_parFormatFromExtension(TPCSTATUS *status);
extern int test_parDefaultExtension(TPCSTATUS *status);
extern int test_parWrite(TPCSTATUS *status);
extern int test_parRead(TPCSTATUS *status);
extern int test_parListLimits(TPCSTATUS *status);
extern int test_parWriteLimits(TPCSTATUS *status);
extern int test_parReadLimits(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* parres */
extern int test_parPrintType(TPCSTATUS *status);
extern int test_parWriteRES(TPCSTATUS *status);
extern int test_parReadRES(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* parfit */
extern int test_parWriteFIT(TPCSTATUS *status);
extern int test_parReadFIT(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* parcomp */
extern int test_parCompareParameterNames(TPCSTATUS *status);
extern int test_parCompareParameterUnits(TPCSTATUS *status);
extern int test_parCompareTacNames(TPCSTATUS *status);
extern int test_parCompareParameters(TPCSTATUS *status);
extern int test_parCompareWSS(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* parselect */
extern int test_parSelectTACs(TPCSTATUS *status);
extern int test_parSelectedTACs(TPCSTATUS *status);
extern int test_parSelectParameters(TPCSTATUS *status);
extern int test_parSelectedParameters(TPCSTATUS *status);
extern int test_parFindParameter(TPCSTATUS *status);
extern int test_parGetParameter(TPCSTATUS *status);
extern int test_parGetParameterUnit(TPCSTATUS *status);
extern int test_parValueRange(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* parorder */
extern int test_parSortByName(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* parexample */
extern int test_parExampleTTACs(TPCSTATUS *status);
extern int test_parExamplePerfectBolus(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
#endif /* TEST_TPCPAR */
